datablock audioProfile( dbItem_fireSound )
{
	fileName = "./item/fire.wav";
	description = audioDefault3d;
	preload = true;
};

datablock audioProfile( dbItem_hitSound )
{
	fileName = "./item/hit.wav";
	description = audioDefault3d;
	preload = true;
};

datablock audioProfile( dbNuke_fireSound )
{
   fileName = "./nuke/fire.wav";
   description = audioClosest3d;
   preload = true;
};

datablock audioProfile( dbNuke_hitSound )
{
   fileName = "./nuke/hit.wav";
   description = audioDefault3d;
   preload = true;
};

datablock particleData( dbItem_particle )
{
	dragCoefficient = 0.1;
	gravityCoefficient = 0;

	inheritedVelFactor = 0;
	constantAcceleration = 0.0;

	lifetimeMS = 200;
	lifetimeVarianceMS = 0;

	useInvAlpha = true;
	textureName = "base/data/particles/thinRing";

	colors[ 0 ] = "0.2 0.9 0 0.5";
	colors[ 1 ] = "0.4 0.9 0 0.0";

	sizes[ 0 ] = 0.1;
	sizes[ 1 ] = 3;

	times[ 0 ] = 0;
	times[ 1 ] = 1;
};

datablock particleEmitterData( dbItem_emitter )
{
	ejectionPeriodMS = 10;
	ejectionVelocity = 16;
	ejectionOffset = 0;

	velocityVariance = 0;
	periodVarianceMS = 0;

	thetaMin = 0;
	thetaMax = 0;

	phiReferenceVel = 0;
	phiVariance = 360;

	overrideAdvance = false;
	particles = dbItem_particle;
};

datablock particleData( dbNuke_particle )
{
	textureName = "base/data/particles/cloud";
	useInvAlpha = false;

	lifetimeMS = 1000; // 3000
	lifetimeVarianceMS = 268.333; // 805

	dragCoefficient = 3;
	gravityCoefficient = 0;

	inheritedVelFactor = 0.15;
	constantAcceleration = 0;

	spinSpeed = 10.0;
	spinRandomMin = -150.0;
	spinRandomMax = 150.0;

	colors[ 0 ] = "1.0 1.0 0.0 0.4";
	colors[ 1 ] = "1.0 0.2 0.0 0.5";
	colors[ 2 ] = "0.20 0.20 0.20 0.3";
	colors[ 3 ] = "0.0 0.0 0.0 0.0";

	sizes[ 0 ] = 0.1875; // 0.75
	sizes[ 1 ] = 0.28; // 1.12
	sizes[ 2 ] = 1.3375; // 5.35
 	sizes[ 3 ] = 0.0125; // 0.05

	times[ 0 ] = 0.0;
	times[ 1 ] = 0.05;
	times[ 2 ] = 0.3;
	times[ 3 ] = 1.0;
};

datablock particleEmitterData( dbNuke_emitter )
{
	ejectionPeriodMS = 5;
	ejectionVelocity = 0.25;
	ejectionOffset = 0.0;

	periodVarianceMS = 1;
	velocityVariance = 0.0;

	thetaMin = 0;
	thetaMax = 90;

	phiReferenceVel = 0;
	phiVariance = 360;

	overrideAdvance = false;
	particles = dbNuke_particle;
};

datablock projectileData( dbNukeProjectile )
{
   projectileShapeName = "./nuke/shape.dts";
   explosion = rocketExplosion;
   lifetime = 30000;
   scale = "1.5 1.5 1.5";

   directDamage = 100;
   directDamageType = $DamageType::RocketDirect;
   radiusDamageType = $DamageType::RocketRadius;

   impactImpulse = 50;
   verticalImpulse = 50;
   particleEmitter = dbNuke_emitter;

   armingDelay = 0;
   fadeDelay = 3500;

   hasLight = true;
   lightRadius = 5.0;
   lightColor = "1 0.5 0.0";

   isDBProjectile = true;
   maxActive = 1;
};

datablock shapeBaseImageData( reflectorImage )
{
	shapeFile = "./item/shape.dts";
	emap = true;

	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0;
	rotation = eulerToMatrix( "0 0 0" );

	correctMuzzleVector = true;
	className = "WeaponImage";

	ammo = " ";
	projectileType = "";

	melee = false;
	armReady = true;

	doColorShift = true;
	colorShiftColor = "0.50 1 0.1 1.000";

	stateName[ 0 ] = "Ready";
	stateAllowImageChange[ 0 ] = false;
	stateTransitionOnTriggerDown[ 0 ] = "Fire";

	stateName[ 1 ] = "Fire";
	stateSound[ 1 ] = dbItem_fireSound;
	stateScript[ 1 ] = "onFire";
	stateEmitter[ 1 ] = dbItem_emitter;
	stateEmitterTime[ 1 ] = 0.005;
	stateEmitterNode[ 1 ] = "muzzleNode";
	stateAllowImageChange[ 1 ] = false;
	stateTransitionOnTriggerUp[ 1 ] = "Wait";

	stateName[ 2 ] = "Wait";
	stateTimeoutValue[ 2 ] = 0.5;
	stateAllowImageChange[ 2 ] = false;
	stateTransitionOnTimeout[ 2 ] = "Ready";
};

datablock playerData( playerDodgeballArmor : playerStandardArmor )
{
	uiName = "";
	canJet = false;

	maxTools = 0;
	maxDamage = 1;
};

datablock fxDTSBrickData( brickSpawnPointData_dbSpawner : brick2x2fData )
{
	category = "Special";
	subCategory = "Dodgeball";
	uiName = "Spawner";

	isDBSpawner = true;
};

datablock fxDTSBrickData( brickSpawnPointData_dbTeam1 : brickSpawnPointData )
{
	subCategory = "Dodgeball";
	uiName = "Team 1 Spawn";

	isDBSpawn = true;
	spawnTeam = 0;
};

datablock fxDTSBrickData( brickSpawnPointData_dbTeam2 : brickSpawnPointData )
{
	subCategory = "Dodgeball";
	uiName = "Team 2 Spawn";

	isDBSpawn = true;
	spawnTeam = 1;
};

rocketLauncherProjectile.isDBProjectile = 1;
rocketLauncherProjectile.maxActive = 2;
