function fxDTSBrick::addToDBStore( %this )
{
	dbBrickGroup.add( %this );
}

function brickSpawnPointData_dbTeam1::onPlant( %this, %obj )
{
	parent::onPlant( %this, %obj );
	%obj.addToDBStore();
}

function brickSpawnPointData_dbTeam2::onPlant( %this, %obj )
{
	parent::onPlant( %this, %obj );
	%obj.addToDBStore();
}

function brickSpawnPointData_dbSpawner::onPlant( %this, %obj )
{
	parent::onPlant( %this, %obj );
	%obj.addToDBStore();
}

function brickSpawnPointData_dbTeam1::onLoadPlant( %this, %obj )
{
	parent::onLoadPlant( %this, %obj );
	%obj.addToDBStore();
}

function brickSpawnPointData_dbTeam2::onLoadPlant( %this, %obj )
{
	parent::onLoadPlant( %this, %obj );
	%obj.addToDBStore();
}

function brickSpawnPointData_dbSpawner::onLoadPlant( %this, %obj )
{
	parent::onLoadPlant( %this, %obj );
	%obj.addToDBStore();
}

function reflectorImage::onFire( %this, %obj, %slot )
{
	if ( !isObject( %cl = %obj.client ) )
	{
		return;
	}

	if ( !isObject( %pl = %cl.player ) )
	{
		return;
	}

	initContainerRadiusSearch( %obj.getEyePoint(), 6, $TypeMasks::ProjectileObjectType );

	while ( isObject( %col = containerSearchNext() ) )
	{
		if ( !%col.getDataBlock().isDBProjectile )
		{
			continue;
		}

		if ( %col.team $= %cl.dbTeam )
		{
			continue;
		}

		%spd = %col.speed * $DB::SpeedUpRate;
		%dir = vectorNormalize( vectorSub( %col.position, %pl.getEyePoint() ) );

		%diff = vectorSub( %dir, vectorNormalize( %pl.getEyeVector() ) );
		%diffLen = vectorLen( %diff );

		if ( %diffLen > 0.5 )
		{
			continue;
		}

		serverPlay3d( dbItem_hitSound, %col.position );
		%col.setName( "tempProjectileVelocityChangeBase" );

		%obj = new projectile( "" : tempProjectileVelocityChangeBase )
		{
			initialVelocity = vectorScale( %dir, %spd );
			velocityModified = true;

			speed = %spd;
			team = %cl.dbTeam;

			sourceObject = %obj;
			homingTarget = "";
		};

		dbProjectileGroup.add( %obj );
		%col.delete();
	}
}

function projectile::dbHomingTick( %this )
{
	cancel( %this.dbHomingTick );

	if ( dbGame.state !$= "active" )
	{
		%this.delete();
		return;
	}

	if ( !strLen( %this.team ) )
	{
		return;
	}

	if ( !isObject( %this.homingTarget ) || %this.homingTarget.getState() $= "Dead" )
	{
		%this.homingTarget = %this.pickHomingTarget();
	}

	if ( !isObject( %this.homingTarget ) )
	{
		%this.dbHomingTick = %this.schedule( 100, "dbHomingTick" );
		return;
	}

	// %add = getRandom( -5, 5 ) SPC getRandom( -5, 5 ) SPC getRandom( -15, 15 );

	%path = vectorNormalize( vectorSub( vectorAdd( %this.homingTarget.getEyePoint(), %add ), %this.position ) );
	%vect = vectorAdd( %this.getVelocity(), vectorScale( %path, %this.speed * $DB::Acceleration ) );

	if ( vectorLen( %vect ) > %this.speed )
	{
		%vect = vectorScale( vectorNormalize( %vect ), %this.speed );
	}

	if ( vectorDist( %this.getVelocity(), %vect ) >= 0.2 )
	{
		%this.setName( "tempProjectileVelocityChangeBase" );

		%obj = new projectile( "" : tempProjectileVelocityChangeBase )
		{
			initialVelocity = %vect;
			velocityModified = true;
		};

		dbProjectileGroup.add( %obj );
		%this.delete();

		if ( !isObject( %obj ) )
		{
			return;
		}

		%this = %obj;
	}

	if ( !isEventPending( %this.dbHomingTick ) )
	{
		%this.dbHomingTick = %this.schedule( 32, "dbHomingTick" );
	}
}

function projectile::pickHomingTarget( %this )
{
	if ( !strLen( %this.team ) )
	{
		return "";
	}

	%count = clientGroup.getCount();

	for ( %i = 0 ; %i < %count ; %i++ )
	{
		%cl = clientGroup.getObject( %i );

		if ( isObject( %pl = %cl.player ) && %pl.getState() !$= "Dead" && %cl.dbTeam !$= %this.team )
		{
			%list = %list @ ( strLen( %list ) ? "\t" : "" ) @ %pl;
		}
	}

	if ( !strLen( %list ) || !getFieldCount( %list ) )
	{
		return "";
	}

	%pl = getField( %list, getRandom( 0, getFieldCount( %list ) - 1 ) );

	// if ( isObject( %pl.client ) )
	// {
	// 	commandToClient( %pl.client, 'CenterPrint', "<font:impact:24><color:FFAAAA>WATCH OUT!", 1 );
	// 	schedule( 333, 0, "commandToClient", %pl.client, 'CenterPrint', "<font:impact:24><color:FFAA55>WATCH OUT!", 0.666 );
	// 	schedule( 666, 0, "commandToClient", %pl.client, 'CenterPrint', "<font:impact:24><color:FFAA00>WATCH OUT!", 0.333 );
	// }

	return %pl;
}
