package rocketReflectPackage
{
	function gameConnection::onClientEnterGame( %this )
	{
		%this.dbTeam = autoPickTeam();
		parent::onClientEnterGame( %this );
	}

	function gameConnection::getSpawnPoint( %this )
	{
		return pickDBSpawn( %this.dbTeam );
	}

	function gameConnection::spawnPlayer( %this )
	{
		if ( dbGame.state $= "starting" && strLen( %this.dbTeam ) )
		{
			parent::spawnPlayer( %this );

			%c0 = "1 0.25 0";
			%c1 = "0 0.25 1";

			if ( isObject( %pl = %this.player ) )
			{
				%pl.clearTools();
				%pl.changeDataBlock( playerDodgeballArmor );
				%pl.mountImage( reflectorImage, 0 );
				%pl.playThread( 1, "armReadyRight" );
				%pl.setShapeNameColor( %c[ %this.dbTeam ] );
			}
		}
		else
		{
			%this.hasSpawnedOnce = true;
			%this.canRespawn = false;
			%this.camera.setFlyMode();
			%this.setControlObject( %this.camera );
		}
	}

	function player::mountImage( %this, %image, %slot )
	{
		parent::mountImage( %this, ( %slot ? %image : reflectorImage ), %slot );
	}

	function player::unmountImage( %this, %slot )
	{
		if ( %slot )
		{
			parent::unmountImage( %this, %slot );
		}
	}

	function player::playThread( %this, %slot, %anim )
	{
		parent::playThread( %this, %slot, ( %slot == 1 ? "armReadyRight" : %anim ) );
	}

	function projectile::onAdd( %this )
	{
		parent::onAdd( %this );

		if ( %this.getDataBlock().isDBProjectile )
		{
			%this.dbHomingTick = %this.schedule( 100, "dbHomingTick" );
		}
	}

	function miniGameCanDamage( %obj, %col )
	{
		if ( !isObject( %col ) )
		{
			return -1;
		}

		if ( !isFunction( %col.getClassName(), "getType" ) )
		{
			return -1;
		}

		if ( !( %col.getType() & $TypeMasks::PlayerObjectType ) )
		{
			return -1;
		}

		return 1;
	}

	function projectileData::onCollision( %this, %obj, %col, %val, %pos, %up, %vel )
	{
		parent::onCollision( %this, %obj, %col, %val, %pos, %up, %vel );

		if ( %this.isDBProjectile )
		{
			cancel( %obj.dbHomingTick );
		}
	}

	function gameConnection::onDeath( %this, %a, %b, %c, %type, %loc )
	{
		parent::onDeath( %this, %a, %b, %c, %type, %loc );
		messageClient( %this, 'MsgYourSpawn' );

		%this.canRespawn = false;
		%this.camera.setFlyMode();
		%this.setControlObject( %this.camera );
		dbGame.checkWin();
	}

	function serverCmdCreateMiniGame() {}
	function servercmdJoinMiniGame() {}
	function observer::onTrigger() {}
	function serverCmdSit() {}
};

deactivatePackage( "dodgeball_package" );
activatePackage(rocketReflectpackage);
